/* mac061997 by HNS/DSITRI hns@computer.org
** scnhdr.h
*/

#ifdef __SC__	/* Symantec C++ for PowerPC 8.0 */
#pragma options align=mac68k
#endif

struct scnhdr {
        char            s_name[8];      /* name of section (e.g., ".text") */
        long            s_paddr;        /* physical addr, used for standalone */
        long            s_vaddr;        /* virtual address */
        long            s_size;         /* size of section */
        long            s_scnptr;       /* file offset of section */
        long            s_relptr;       /* points to relocs for section */
        long            s_lnnoptr;      /* points to line numbers for section */
        unsigned short  s_nreloc;       /* # of relocs */
        unsigned short  s_nlnno;        /* # of line no's */
        long            s_flags;        /* section flags -- see below */
};

enum scnhdr_flags {
        STYP_REG = 0x00,        /* regular (alloc'ed, reloc'ed, loaded) */
        STYP_DSECT = 0x01,      /* dummy   (reloc'd) */
        STYP_NOLOAD = 0x02,     /* no-load (reloc'd) */
        STYP_GROUP = 0x04,      /* grouped */
        STYP_PAD = 0x08,        /* padding (loaded) */
        STYP_COPY = 0x10,       /* ??? */
        STYP_TEXT = 0x20,       /* text */
        STYP_DATA = 0x40,       /* data */
        STYP_BSS = 0x80,        /* bss */
        STYP_INFO = 0x200,      /* comment (!loaded, !alloc'ed, !reloc'd) */
        STYP_OVER = 0x400,      /* overlay (!allocated, reloc'd, !loaded) */
        STYP_LIB = 0x800        /* lists shared library files */
};

#define SCNHDR struct scnhdr
#define SCNHSZ sizeof(SCNHDR)

#ifdef __SC__	/* Symantec C++ for PowerPC 8.0 */
#pragma options align=reset
#endif

/* EOF */