/* mac061997,98 by HNS/DSITRI hns@computer.org
** signal.h
*/

#pragma once

typedef void (*__SIGFUNCP)(long);

#define SIG_DFL		((__SIGFUNCP) 0)	/* default */
#define SIG_ERR		((__SIGFUNCP) -1)	/* error */
#define SIG_IGN		((__SIGFUNCP) 1)	/* ignore */

#define SIGHUP		1		/* connection to controlling terminal is lost */
#define SIGINT		2		/* user interrupt */
#define SIGQUIT		3		/* user quit */
#define SIGABRT		3		/* user abort */
#define SIGILL		4		/* illegal instruction */
#define SIGTRAP		5		/* trap instruction */
#define SIGFPE		8		/* floating point exception */
#define SIGKILL		9		/* kill process */
#define SIGSEGV		11		/* address error */
#define SIGSYS		12		/* invalid system call argument */
#define SIGPIPE		13		/* pipe reading process has terminated */
#define SIGALRM		14		/* timeout of alarm() system call */
#define SIGTERM		15		/* default request to terminate */
#define SIGCHLD		16
#define SIGCONT		17
#define SIGSTOP		18
#define SIGTSTP		19
#define SIGTTIN		20
#define SIGTTOU		21
#define SIGUSR1		22
#define SIGUSR2		23

int kill(int pid, int sig);
#define raise(S) kill((S), getpid())
__SIGFUNCP signal(int sig, __SIGFUNCP proc);

/* EOF */