/* mac061997 by HNS/DSITRI hns@computer.org
** stdlib.h
*/

#pragma once

#include "size_t.h"
#include "wchar_t.h"

#define EXIT_FAILURE 	1
#define EXIT_SUCCESS 	0
#ifndef NULL
#define NULL 			(0)
#endif
#define RAND_MAX		32767

typedef struct { int quot, rem; } div_t;
typedef struct { long quot, rem; } ldiv_t;

#ifndef _STD_C_ONLY
extern char **environ;
#endif

int abort(void);
int abs(int val);
int atexit(void (*fn)(void));
/* double atof(char *num); */
int atoi(char *num);
long atol(char *num);
int bsearch(const void *key, const void *base, size_t nmemb, size_t site,
      int (compar)(const void *, const void *));
void *calloc(size_t nmemb, size_t size);
div_t div(int num, int den);
int exit(int code);
void free(void *block);
char *getenv(char *var);
long labs(long int val);
ldiv_t ldiv(long int num, long int den);
void *malloc(size_t size);
void qsort(void *base, size_t nmemb, size_t size,
      int (compar)(const void *, const void *));
int rand(void);
void *realloc(void *block, size_t size);
void srand(unsigned int seed);
/* double strtod(const char *n, char **end); */
long strtol(const char *n, char **end, int base);
unsigned long strtoul(const char *n, char **end, int base);
int system(char *command);

#ifdef macintosh
#define main __main	/* this is done to insert startup code */
int __main(int argc, char **argv);	/* in crthost.o */
#endif

/* EOF */