/* mac061997,98 by HNS/DSITRI hns@computer.org
** sys/stat.h
*/

#pragma once
#include "time.h"
#include "sys/types.h"

#ifdef __SC__	/* Symantec C++ for PowerPC 8.0 */
#pragma options align=mac68k
#endif

struct stat
	{ /* inode information returned by stat/fstat */
	dev_t		st_dev;		/* device of the inode */
	ino_t		st_ino;		/* inode number */
	mode_t		st_mode;	/* file mode */
	nlink_t		st_nlink;	/* number of links to file */
	uid_t		st_uid;		/* user id */
	gid_t		st_gid;		/* group id */
	dev_t		st_rdev;	/* for device files */
	off_t		st_size;	/* file size in bytes */
	time_t		st_atime;	/* time of last access */
	time_t		st_mtime;	/* time last modification */
	time_t		st_ctime;	/* time of original create */
	};

#ifdef __SC__
#pragma options align=reset
#endif

#define S_IRWXU		0000700		/* mask for owner */
#define S_IRUSR		0000400
#define S_IWUSR		0000200
#define S_IXUSR		0000100
#define S_IRWXG		0000070		/* mask for group */
#define S_IRGRP		0000400
#define S_IWGRP		0000200
#define S_IXGRP		0000100
#define S_IRWXO		0000007		/* mask for other */
#define S_IROTH		0000400
#define S_IWOTH		0000200
#define S_IXOTH		0000100

#ifndef _POSIX_SOURCE
#define S_ISTICKY	0001000
#endif
#define S_ISGID		0002000
#define S_ISUID		0004000

#define S_IFREG		0000000
#define S_IFIFO		0010000
#define S_IFCHR		0020000
#define S_IFDIR		0040000
#define S_IFBLK		0060000
#define S_IFTYPE	0170000

#define S_ISDIR(m)	(((m)&S_IFTYPE) == S_IFDIR)
#define S_ISCHR(m)	(((m)&S_IFTYPE) == S_IFCHR)
#define S_ISBLK(m)	(((m)&S_IFTYPE) == S_IFBLK)
#define S_ISREG(m)	(((m)&S_IFTYPE) == S_IFREG)
#define S_ISFIFO(m)	(((m)&S_IFTYPE) == S_IFIFO)
#ifndef _POSIC_SOURCE
#define S_IFLNK		0030000
#define S_ISSLNK(m)	(((m)&S_IFTYPE) == S_IFLNK)
#endif

int chmod(const char *name, mode_t mode);
int chown(const char *name, uid_t uid, gid_t gid);
int fstat(int fd, struct stat *buf);
int mkdir(const char *name, mode_t mode);
int mkfifo(const char *name);
int stat(const char *name, struct stat *buf);
int umask(mode_t mask);

/* EOF */