/* mac061997 by HNS/DSITRI hns@computer.org
** time.h
*/

#pragma once

#include "size_t.h"
#include "clock_t.h"
#include "time_t.h"

#ifndef NULL
#define NULL			(0)
#endif

#ifdef __SC__	/* Symantec C++ for PowerPC 8.0 */
#pragma options align=mac68k
#endif

#ifndef _POSIX_SOURCE
struct timeval
	{
	long tv_sec;
	long tv_usec;
	};

struct timezone
	{
	short tz_minuteswest;
	short tz_dstime;
	};
#endif

struct tm
	{
	short tm_sec;
	short tm_min;
	short tm_hour;
	short tm_mday;	/* month day (1...31) */
	short tm_mon;	/* month (0=Jan ... 11=Dec) */
	short tm_wday;	/* day of week (0=Sunday) */
	short tm_year;	/* full year number */
	short tm_yday;	/* days since Jan 1. */
	short tm_isdst;	/* daylight savings flag */
	};

#ifdef __SC__
#pragma options align=reset
#endif

extern char *tzname[2];

char *asctime(const struct tm *tp);
clock_t clock(void);
#define ctime(tp) asctime(gmtime(tp))
/* double difftime(time_t t1, time_t t0); */
struct tm *gmtime(const time_t *tp);
struct tm *localtime(const time_t *tp);
time_t mktime(struct tm *tp);
size_t strftime(char *s, size_t size, const char *fmt, const struct tm *tp);
time_t time(time_t *tp);
void tzset(void);
#ifndef _POSIX_SOURCE
int gettimeofday(struct timeval *, struct timezone *);
#endif


/* EOF */